﻿# CMA - CheeTaHs Map Adverts
## ..addons/eventscripts/cma/cma.py

# Special thanks to L'in20cible for helping me with creating decals! (:

import es
import time
import cmdlib
import playerlib
from configobj import ConfigObj

PlayersThatSeesDecals = []

currentmap = es.ServerVar('eventscripts_currentmap')

map_decals = ConfigObj(es.getAddonPath('cma') + '/map_decals.ini')

def load():
    DownAndPrecache()
    for players in playerlib.getUseridList("#all"):
        PlayersThatSeesDecals.append(str(players))
    cmdlib.registerServerCommand('!cma', AddDecal, "!cma <map> <x> <y> <z> <material>")

def unload():
    cmdlib.unregisterServerCommand('!cma')

def es_map_start(ev):
    DownAndPrecache()

def player_spawn(ev):
    if ev['userid'] not in PlayersThatSeesDecals:
        if int(ev['es_userteam']) > 0:
            PlayersThatSeesDecals.append(ev['userid'])
            DrawDecals()
        
def player_say(ev):
    if ev['text'].lower() != '!pow':
        return
    x, y, z = playerlib.getPlayer(ev['userid']).getViewCoord().split(",")
    es.tell(ev['userid'],'#multi','#green%s#default, #green%s#default, #green%s' %(x,y,z))

def AddDecal(args=None):
    if not args:
        es.dbgmsg(0, "Syntax: !cma <map> <x> <y> <z> <material>")
        return
    if not len(args) == 5:
        es.dbgmsg(0, "Syntax: !cma <map> <x> <y> <z> <material>")
        return
    if not es.exists('map', args[0]):
        es.dbgmsg(0, '!cma: Invalid Mapname: ' + args[0])
        return
        
    TIME = str(time.time())
    config = ConfigObj(es.getAddonPath('cma') + '/map_decals.ini')
    if args[0] not in config:
        config[args[0]] = {}
    config[args[0]][TIME] = {}
    config[args[0]][TIME]['x'] = args[1]
    config[args[0]][TIME]['y'] = args[2]
    config[args[0]][TIME]['z'] = args[3]
    config[args[0]][TIME]['material'] = args[4]
    config[args[0]][TIME]['comment'] = 'Added by Console!'
    config.write()

def DownAndPrecache():
    PubVarVersion = "1.1CheeTaH-Public"
    PubVar = es.ServerVar("cma_version",PubVarVersion,"Script Version")
    PubVar.set(PubVarVersion)
    PubVar.makepublic()
    for MAPS in map_decals:
        for UNIQUES in map_decals[MAPS]:
            theFile = 'materials/' + map_decals[MAPS][UNIQUES]['material']
            es.precachedecal(theFile)
            es.stringtable('downloadables', theFile)
    DrawDecals()
    
def DrawDecals():
    CurrentMap = str(currentmap)
    if not CurrentMap in map_decals:
        return
        
    userid = es.getuserid()
    if not userid:
        return
        
    for userid in es.getUseridList():
        if not es.isbot(userid):
            es.cexec(userid, "r_cleardecals 1")
   
    for decal in map_decals[CurrentMap]:
        index = es.createentity('infodecal')
        es.entitysetvalue(index, 'texture', map_decals[CurrentMap][decal]['material'])
        es.entitysetvalue(index, 'origin', ' '.join([map_decals[CurrentMap][decal][x] for x in 'xyz']))
    es.server.insertcmd('es_xfire %s infodecal Activate' % userid)